"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const reorderParams_1 = require("./refactors/reorderParams");
const removeParam_1 = require("./refactors/removeParam");
exports.PLUGIN_NAME = 'typescript-plugin-function-signature-refactors';
function getRefactors(options) {
    if (!refactors) {
        refactors = [new reorderParams_1.ReorderParamsCodeFixImpl(options), new removeParam_1.removeParamsCodeFixImpl(options)];
    }
    return refactors;
}
exports.getRefactors = getRefactors;
let refactors;
//# sourceMappingURL=refactors.js.map